<?php

// +---------------------------------------------------------------------------+
// | Geeklog 1.4                                                               |
// +---------------------------------------------------------------------------+
// | pluginmanager.php                                                         |
// |                                                                           |
// | Geeklog plugin management page, using PEAR_Frontend_Web.                  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000-2006 by the following authors:                         |
// |                                                                           |
// | Authors: Tias Guns         - tias AT php DOT net                          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

require_once ('../lib-common.php');
require_once ('auth.inc.php');

// Uncomment the line below if you need to debug the HTTP variables being passed
// to the script.  This will sometimes cause errors but it will allow you to see
// the data being passed in a POST operation
// echo COM_debug($_POST);

// Copied directly from admin/plugins.php
if (!SEC_hasrights ('plugin.edit')) {
    $display = '';
    $display .= COM_siteHeader ('menu', $MESSAGE[30]);
    $display .= COM_startBlock ($MESSAGE[30], '',
                                COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $MESSAGE[38];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("User {$_USER['username']} tried to illegally access the plugin administration screen.");
    echo $display;
    exit;
}

if (isset($_GET['img']) || isset($_GET['css']) || isset($_GET['js'])) {
    // if binary/web data, pass directly !
    pear_frontend_web(null, null);
    exit;
}

/**
 * Filters out the packages (plugins) that are already registered
 * in the plugin registry.
 */
function filter_registered_plugins(&$reg, $packages)
{
    $channels = $reg->listChannels();

    $all_pkgs = array();
    foreach ($channels as $channel) {
        // why can't we just delete those unneeded channels ? grrr
        if ($channel == 'pear.php.net' || $channel == 'pecl.php.net') {
            break;
        }
        $all_pkgs = array_merge($reg->listPackages($channel), $all_pkgs);
    }

    $unregistered = array();
    foreach ($packages as $pkg) {
        if (!in_array(strtolower($pkg), $all_pkgs)) {
            $unregistered[] = $pkg;
        }
    }
        
    return $unregistered;
}

/**
 * Tries to register given plugins (they are not registered yet)
 * Returns all plugins that are not available on the channels
 */
function register_plugins(&$config, $plugins) {
    // This code is copied from PEAR_Frontend_Web's
    // Command/Categories.php
    // I wish stuff like this would be easier
    $reg = &$config->getRegistry();
    PEAR_Frontend::setFrontendClass('PEAR_Frontend_CLI');
    $ui = &PEAR_Command::getFrontendObject();
    if (PEAR::isError($ui)) {
        die('<b>UI Error:</b> '.$ui->getMessage());
    }
    $ui->setConfig($config);
    $savechannel = $config->get('default_channel');
    $channels = $reg->listChannels();

    foreach ($channels as $channel) {
        // channels that are installed for some unfixable reason,
        // but will never contain plugins and surely no preinstalled ones
        if ($channel == 'pear.php.net' || $channel == 'pecl.php.net'
            || $channel == '__uri' || $channel == 'pearified.com') {
            continue;
        }

        $chan = &$reg->getChannel($channel);
        // we need Remote::_checkChannelForStatus(),
        // which is supposed to be private : /
        require_once 'PEAR/Command/Remote.php';
        $cmd = new PEAR_Command_Remote($ui, $config);
        if (PEAR::isError($e = $cmd->_checkChannelForStatus($channel, $chan))) {
            continue; // can't get plugins from here
        }
        if ($chan->supportsREST($config->get('preferred_mirror')) &&
              $base = $chan->getBaseURL('REST1.0', $config->get('preferred_mirror'))) {
            $rest = &$config->getREST('1.0', array());
            $packages = $rest->listPackages($base);
        } else {
            continue; // can't get plugins from here
        }
        if (PEAR::isError($packages)) {
            continue; // can't get plugins from here
        }

        foreach ($plugins as $i => $plugin) {
            if (in_array($plugin, $packages)) {
                // this plugin is from this channel, lets register it that way
                $cmd = PEAR_Command::factory('install', $config);
                $opts = array('register-only' => true);
                $plugin_pkg = $channel.'/'.$plugin.'-alpha'; // alpha = we don't care what state
                $ok = $cmd->run('install', $opts, array($plugin_pkg));
                if (PEAR::isError($ok)) {
                    print('PEAR Error: '.$ok->getMessage());
                }
            }
            unset($plugins[$i]);
        }
    }

    $config->set('default_channel', $savechannel);
    return $plugins;
}

// Headers
$display = COM_siteHeader ('menu', $LANG32[5]);
if (isset ($_REQUEST['msg'])) {
    $msg = COM_applyFilter ($_REQUEST['msg'], true);
    if (!empty ($msg)) {
        $plugin = '';
        if (isset ($_REQUEST['plugin'])) {
            $plugin = COM_applyFilter ($_REQUEST['plugin']);
        }
        $display .= COM_showMessage ($msg, $plugin);
    }
}
echo $display;

require_once 'PEAR/Registry.php';
require_once 'PEAR/Config.php';
require_once 'PEAR/Command.php';

$plugins_dir = $_CONF['path'].DIRECTORY_SEPARATOR.'plugins';
$registry_dir = $plugins_dir.DIRECTORY_SEPARATOR.'plugin_registry';
$plugin_conf = $registry_dir.DIRECTORY_SEPARATOR.'pear.conf';

// Verify the plugin (pear) configuration file exists
if (!file_exists($plugin_conf)) {
    print('<p>The plugin registry does not exist yet, creating it now... (ignore any text that follows)</p>');
    if (!file_exists($registry_dir) && !is_writable($plugins_dir)) {
        print('<em>Error: the plugins directory is not writable ('.$plugins_dir.'). You must change its permissions so the webserver can write to it.<br /> (+explain how)</em>');
        print sprintf('<p><a href="%s">After changing the permissions, click here.</a></p>',
                    $_SERVER['PHP_SELF']);
        exit;
    }

    if (file_exists($registry_dir) && !is_writable($registry_dir)) {
        print('<em>Error: the plugin registry directory is not writable ('.$registry_dir.'). You must change its permissions so the webserver can write to it.<br /> (+explain how)</em>');
        print sprintf('<p><a href="%s">After changing the permissions, click here.</a></p>',
                    $_SERVER['PHP_SELF']);
        exit;
    }

    if (!file_exists($registry_dir) ||
        !file_exists($registry_dir.DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.'download')) {
        // create registry and base dirs, as required by PEAR
        // thank god PEAR creates the registry itself on first usage ; )
        $dirs = array($registry_dir,
                      $registry_dir.DIRECTORY_SEPARATOR.'docs',
                      $registry_dir.DIRECTORY_SEPARATOR.'data',
                      $registry_dir.DIRECTORY_SEPARATOR.'test',
                      $registry_dir.DIRECTORY_SEPARATOR.'temp',
                      $registry_dir.DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.'download',
                      $registry_dir.DIRECTORY_SEPARATOR.'cache');
        foreach ($dirs as $dir) {
            if (!file_exists($dir)) {
                mkdir($dir);
            } elseif (!is_writable($dir)) {
                print('<em>Error: a plugin registry subdirectory is not writable ('.$dir.'). You must change its permissions so the webserver can write to it.<br /> (+explain how)</em>');
                print sprintf('<p><a href="%s">After changing the permissions, click here.</a></p>',
                    $_SERVER['PHP_SELF']);
            }
        }
    }

    // create clean config for the plugins
    // code taken from PEAR_Frontend_Web
    $frontend &= PEAR_Frontend::setFrontendClass('PEAR_Frontend_CLI');
    if (PEAR::isError($frontend)) {
        die('<b>Frontend Error:</b> '.$frontend->getMessage());
    }

    $config = &PEAR_Config::singleton($plugin_conf, '');
    if (PEAR::isError($config)) {
        die('<b>Config Error:</b> '.$config->getMessage());
    }

    $ui = &PEAR_Command::getFrontendObject();
    if (PEAR::isError($ui)) {
        die('<b>UI Error:</b> '.$ui->getMessage());
    }
    $ui->setConfig($config);
    
    print('<p>Saving config file ('.$plugin_conf.')...</p>');
    // First of all set some config-vars:
    $cmd = PEAR_Command::factory('config-set', $config);
    $ok = $cmd->run('config-set', array(), array('php_dir', $registry_dir));
    $ok = $cmd->run('config-set', array(), array('web_dir', $_CONF['path'])); // Role_Web

    // we don't care about the other config values, but set them anyways
    $pear_dir = $registry_dir.DIRECTORY_SEPARATOR;
    $ok = $cmd->run('config-set', array(), array('doc_dir',  $pear_dir.'docs'));
    $ok = $cmd->run('config-set', array(), array('data_dir', $pear_dir.'data'));
    $ok = $cmd->run('config-set', array(), array('test_dir', $pear_dir.'test'));
    $ok = $cmd->run('config-set', array(), array('temp_dir', $pear_dir.'temp'));
    $ok = $cmd->run('config-set', array(), array('download_dir', $pear_dir.'temp'.DIRECTORY_SEPARATOR.'download'));
    $ok = $cmd->run('config-set', array(), array('cache_dir', $pear_dir.'/cache'));
    $ok = $cmd->run('config-set', array(), array('cache_ttl', 300));


    print('<p>Checking package registry...</p>');
    $reg = &$config->getRegistry();
    if (PEAR::isError($reg)) {
        die('<b>Registry Error:</b> '.$reg->getMessage());
    }
    // first fake to install the dreaded Role_web that the plugins depend on
    // this should really be taken off, and become a dep on Geeklog
    $cmd = PEAR_Command::factory('channel-discover', $config);
    $ok = $cmd->run('channel-discover', array(), array('pear.geeklog.net'));
    $ok = $cmd->run('channel-discover', array(), array('pearified.com'));
    $cmd = PEAR_Command::factory('install', $config);
    $ok = $cmd->run('install', array('register-only' => true), array('pearified/Role_Web'));

    $cmd = PEAR_Command::factory('config-set', $config);
    $ok = $cmd->run('config-set', array(), array('default_channel', 'pear.geeklog.net'));
    $cmd = PEAR_Command::factory('channel-delete', $config);
    $ok = $cmd->run('channel-delete', array(), array('pearified.com'));
    //$ok = $cmd->run('channel-delete', array(), array('pecl.php.net'));
    //$ok = $cmd->run('channel-delete', array(), array('pear.php.net'));
}

    $config = &PEAR_Config::singleton($plugin_conf, '');
    if (PEAR::isError($config)) {
        die('<b>Config Error:</b> '.$config->getMessage());
    }
    $reg = &$config->getRegistry();
    if (PEAR::isError($reg)) {
        die('<b>Registry Error:</b> '.$reg->getMessage());
    }

    // Register already installed (and/or required) plugins:
    $result = DB_query("SELECT pi_name FROM {$_TABLES['plugins']}");
    $packages = array();
    while ($A = DB_fetchArray($result)) {
        $packages[] = 'Geeklog_Plugin_'.ucfirst($A['pi_name']);
    }

    $unregistered_plugins = filter_registered_plugins($reg, $packages);

    if (count($unregistered_plugins) !== 0) {
        print('<p>Please wait while trying to register currently installed plugins...</p>');
        $unknown_plugins = register_plugins($config, $unregistered_plugins);

        if (count($unknown_plugins) !== 0) {
            print('<p><b>Following packages are unknown to the system:</b> ');
            print(implode($unknown_plugins, ', '));
        }
    }

// Show the frontend
pear_frontend_web($registry_dir, $plugin_conf);

/**
 * Calls the pear_frontend_web code that displays...
 * the geeklog plugin manager.
 */
function pear_frontend_web($pear_dir, $pear_user_config)
{
    // This code is copied from the index.php.txt file supplied by
    // an installed PEAR_Frontend_Web

    $pear_frontweb_protected = true;

    // our $pear_dir is a phony one, only used for the registry
    require_once('PEAR.php');
    require_once('pearfrontendweb.php');
}


// Footer
echo COM_siteFooter();

?>
